"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mu = require("mzmu");
/**
 * 重写控制 console
 * 控制 console 按执行环境输出
 */
var MnLoggerService = (function () {
    function MnLoggerService() {
        /**
             * 根据状态是否显示
             */
        this._state = true;
        this._place = '[MasterNG]';
    }
    MnLoggerService.prototype.setState = function (state) {
        this._state = state;
    };
    MnLoggerService.prototype.Log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift(this._place);
        console.log.apply(console, args);
    };
    MnLoggerService.prototype.Warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift(this._place);
        console.warn.apply(console, args);
    };
    MnLoggerService.prototype.Error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift(this._place);
        console.error.apply(console, args);
    };
    MnLoggerService.prototype.Info = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift(this._place);
        console.log.apply(console, args);
    };
    MnLoggerService.prototype.Debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift(this._place);
        console.log.apply(console, args);
    };
    MnLoggerService.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this._state && this.Log.apply(this, args);
    };
    MnLoggerService.prototype.warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this._state && this.Warn.apply(this, args);
    };
    MnLoggerService.prototype.error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this._state && this.Error.apply(this, args);
    };
    MnLoggerService.prototype.info = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this._state && this.Info.apply(this, args);
    };
    MnLoggerService.prototype.debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this._state && this.Debug.apply(this, args);
    };
    MnLoggerService.prototype.string = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var _args = mu.map(args, function (o) {
            try {
                return JSON.stringify(o);
            }
            catch (e) {
                return o;
            }
        });
        this._state && this.Debug.apply(this, args);
    };
    MnLoggerService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MnLoggerService.ctorParameters = function () { return []; };
    return MnLoggerService;
}());
exports.MnLoggerService = MnLoggerService;
//# sourceMappingURL=mn-logger.service.js.map