"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
var mn_date_class_1 = require("./mn-date.class");
var mn_logger_service_1 = require("../mn-common/services/mn-logger.service");
var mu = require("mzmu");
/**
 * 构建日期视图
 */
var MnDateMultipleComponent = (function () {
    function MnDateMultipleComponent(_logger) {
        var _this = this;
        this._logger = _logger;
        this.date$ = new BehaviorSubject_1.BehaviorSubject({});
        this.date$_ = {};
        this._view = 'days';
        this._multiple = true;
        this._disabled = false;
        // 手动配置 disabled 时，权重最大
        this._disabled$ = false;
        this._result = new core_1.EventEmitter();
        this._selected = new core_1.EventEmitter();
        this._prev = {};
        this._next = {};
        this.calculation = mu.debounce(function (dates) {
            var _a = dates._minDate, _minDate = _a === void 0 ? {} : _a, _b = dates._maxDate, _maxDate = _b === void 0 ? {} : _b, _c = dates._startDate, _startDate = _c === void 0 ? {} : _c, _d = dates._endDate, _endDate = _d === void 0 ? {} : _d;
            // this._logger.debug(
            //     '~~ minDate :::', _minDate['_d']);
            // this._logger.debug(
            //     '~~ maxDate :::', _maxDate['_d']);
            // this._logger.debug(
            //     '~~ startDate :::', _startDate['_d']);
            // this._logger.debug(
            //     '~~ endDate :::', _endDate['_d']);
            _minDate = mu.ifempty(_minDate, new mn_date_class_1.MnDate('100-01-01'));
            _maxDate = mu.ifempty(_maxDate, new mn_date_class_1.MnDate('9999-12-12'));
            /**
                     * 时间异常
                     *
                     *  _minDate === _maxDate
                     *  _startDate > _endDate
                     *  _minDate > _maxDate
                     *  _minDate > _endDate
                     *  _startDate > _maxDate
                     */
            if (_minDate._ts === _maxDate._ts) {
                _this._disabled = true;
                _this._logger.Error('exception :::: ', 'minDate equal maxDate');
                _this._result.emit({
                    disable: true
                });
                return;
            }
            if (_minDate._ts > _maxDate._ts) {
                _this._disabled = true;
                _this._logger.Error('exception :::: ', 'minDate greater than maxDate');
                _this._result.emit({
                    disable: true
                });
                return;
            }
            // 若开始结束时间不存在
            if (mu.isEmpty(_startDate) && mu.isEmpty(_endDate)) {
                _this._disabled = false;
                _this._result.emit({
                    maxDate: _this._maxDate,
                    minDate: _this._minDate,
                    disable: false
                });
                _this.getViewInfo();
                return;
            }
            if (mu.isNotEmpty(_endDate) && _minDate._ts > _endDate._ts) {
                _this._disabled = true;
                _this._result.emit({
                    disabled: true
                });
                _this._logger.Error('exception :::: ', 'minDate greater than endDate');
                return;
            }
            if (mu.isNotEmpty(_startDate) && _startDate._ts > _maxDate._ts) {
                _this._disabled = true;
                _this._result.emit({
                    disabled: true
                });
                _this._logger.Error('exception :::: ', 'startDate greater than maxDate');
                return;
            }
            if (mu.isNotEmpty(_startDate) && mu.isNotEmpty(_endDate) && _startDate._ts > _endDate._ts) {
                _this._disabled = true;
                _this._result.emit({
                    disabled: true
                });
                _this._logger.Error('exception :::: ', 'startDate greater than endDate');
                return;
            }
            /**
                     * 时间区间重新计算
                     *
                     * 1. _startDate < _minDate < _endDate
                     * // => _startDate = _minDate
                     *
                     * 2. _startDate < _maxDate < _endDate
                     * // => _endDate = _maxDate
                     */
            if (mu.isNotEmpty(_startDate) && _startDate._ts < _minDate._ts) {
                _startDate = _minDate.clone();
                _this._logger.Warn('warning :::: ', 'startDate less than endDate');
            }
            if (mu.isNotEmpty(_endDate) && _maxDate._ts < _endDate._ts) {
                _endDate = _maxDate.clone();
                _this._logger.Warn('warning :::: ', 'maxDate less than endDate');
            }
            _this._disabled = false;
            _this._startDate = _startDate;
            _this._endDate = _endDate;
            _this._result.emit({
                disabled: false,
                startDate: _this._startDate,
                endDate: _this._endDate,
                maxDate: _this._maxDate,
                minDate: _this._minDate,
            });
            /**
                     * 获取两个视图信息
                     */
            /**
             * 获取两个视图信息
             */
            _this.getViewInfo();
        }, 300);
        this.getStartEnd_ = mu.debounce(function (ds) {
            _this._startDate = ds.startDate;
            _this._endDate = ds.endDate;
            if (_this._multiple) {
                if (mu.isNotEmpty(_this._endDate)) {
                    _this._selected.emit(ds);
                }
            }
            else {
                if (mu.isNotEmpty(_this._startDate)) {
                    _this._selected.emit(ds);
                }
            }
        }, 100);
    }
    Object.defineProperty(MnDateMultipleComponent.prototype, "maxDate_", {
        set: function (dt) {
            var _this = this;
            var _maxDate = new mn_date_class_1.MnDate(dt);
            mu.run(_maxDate, function () {
                _this.date$_ = tslib_1.__assign({}, _this.date$_, { _maxDate: _maxDate });
                _this._maxDate = _maxDate;
                _this.date$.next(_this.date$_);
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDateMultipleComponent.prototype, "minDate_", {
        set: function (dt) {
            var _this = this;
            var _minDate = new mn_date_class_1.MnDate(dt);
            mu.run(_minDate, function () {
                _this.date$_ = tslib_1.__assign({}, _this.date$_, { _minDate: _minDate });
                _this._minDate = _minDate;
                _this.date$.next(_this.date$_);
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDateMultipleComponent.prototype, "startDate_", {
        set: function (dt) {
            var _startDate = new mn_date_class_1.MnDate(dt);
            this.date$_ = tslib_1.__assign({}, this.date$_, { _startDate: _startDate });
            this.date$.next(this.date$_);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDateMultipleComponent.prototype, "endDate_", {
        set: function (dt) {
            var _endDate = new mn_date_class_1.MnDate(dt);
            this.date$_ = tslib_1.__assign({}, this.date$_, { _endDate: _endDate });
            this.date$.next(this.date$_);
        },
        enumerable: true,
        configurable: true
    });
    MnDateMultipleComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.date$.subscribe(function (dates) { return _this.calculation(dates); });
    };
    /**
     * 获取两个视图信息
     */
    /**
         * 获取两个视图信息
         */
    MnDateMultipleComponent.prototype.getViewInfo = /**
         * 获取两个视图信息
         */
    function () {
        var _a = this, _startDate = _a._startDate, _endDate = _a._endDate, _maxDate = _a._maxDate, _minDate = _a._minDate;
        // 单日历视图
        if (!this._multiple) {
            if (mu.isNotEmpty(_startDate)) {
                this._prev = _startDate.clone();
            }
            return;
        }
        /**
                 * 没有设置初始时间，则默认视图显示当前时间
                 */
        if (mu.isEmpty(_startDate) && mu.isEmpty(_endDate)) {
            if (mu.isNotEmpty(_maxDate)) {
                this._next = _maxDate.clone();
                this._prev = new mn_date_class_1.MnDate(this._next.mom(-1).start);
                return;
            }
            else if (mu.isNotEmpty(_minDate)) {
                this._prev = _minDate.clone();
                this._next = new mn_date_class_1.MnDate(this._prev.mom(1).start);
                return;
            }
            else {
                this._prev = new mn_date_class_1.MnDate(new Date());
                this._next = new mn_date_class_1.MnDate(this._prev.mom(1).start);
                return;
            }
        }
        if (mu.isEmpty(_startDate) && mu.isNotEmpty(_endDate)) {
            this._prev = _endDate.clone();
            this._next = new mn_date_class_1.MnDate(this._prev.mom(1).start);
            return;
        }
        if (mu.isNotEmpty(_startDate)) {
            this._prev = _startDate.clone();
            this._next = new mn_date_class_1.MnDate(this._prev.mom(1).start);
            if (mu.prop(_startDate, 'months.start') === mu.prop(_endDate, 'months.start')
                || mu.isEmpty(_endDate)) {
                this._next = new mn_date_class_1.MnDate(this._prev.mom(1).start);
            }
            else {
                this._next = _endDate.clone();
            }
        }
    };
    MnDateMultipleComponent.prototype.getPreCalendar = function (prev) {
        this._prev = prev;
    };
    MnDateMultipleComponent.prototype.getNextCalendar = function (next) {
        this._next = next;
    };
    MnDateMultipleComponent.prototype.getStartEnd = function ($event) {
        this.getStartEnd_($event);
    };
    MnDateMultipleComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'mn-datemultiple',
                    template: "\n        <mn-fill [gutter]=\"16\">\n            <mn-col [span]=\"1\">\n                <mn-datecalendar\n                        [mnMinDate]=\"_minDate\"\n                        [mnMaxDate]=\"_maxDate\"\n                        [mnStartDate]=\"_startDate\"\n                        [mnEndDate]=\"_endDate\"\n                        [mnHoverDate]=\"_hoverDate\"\n                        [mnView]=\"_view\"\n\n                        [mnYear]=\"_prev?.days?.year\"\n                        [mnMonth]=\"_prev?.days?.month\"\n\n                        [mnNextDate]=\"_next\"\n\n                        [mnDisabled]=\"_disabled$ || _disabled\"\n                        [mnMultiple]=\"_multiple\"\n\n                        (mnResult)=\"getPreCalendar($event)\"\n                        (mnStartEnd)=\"getStartEnd($event)\"\n                        (mnHover)=\"_hoverDate = $event\"></mn-datecalendar>\n            </mn-col>\n\n            <mn-col [span]=\"1\" *ngIf=\"_multiple\">\n                <mn-datecalendar\n                        [mnMinDate]=\"_minDate\"\n                        [mnMaxDate]=\"_maxDate\"\n                        [mnStartDate]=\"_startDate\"\n                        [mnEndDate]=\"_endDate\"\n                        [mnHoverDate]=\"_hoverDate\"\n                        [mnView]=\"_view\"\n\n                        [mnYear]=\"_next?.days?.year\"\n                        [mnMonth]=\"_next?.days?.month\"\n\n                        [mnPrevDate]=\"_prev\"\n\n                        [mnDisabled]=\"_disabled$ || _disabled\"\n                        [mnMultiple]=\"_multiple\"\n\n                        (mnResult)=\"getNextCalendar($event)\"\n                        (mnStartEnd)=\"getStartEnd($event)\"\n                        (mnHover)=\"_hoverDate = $event\"></mn-datecalendar>\n            </mn-col>\n\n        </mn-fill>\n    "
                },] },
    ];
    /** @nocollapse */
    MnDateMultipleComponent.ctorParameters = function () { return [
        { type: mn_logger_service_1.MnLoggerService, },
    ]; };
    MnDateMultipleComponent.propDecorators = {
        "maxDate_": [{ type: core_1.Input, args: ['mnMaxDate',] },],
        "minDate_": [{ type: core_1.Input, args: ['mnMinDate',] },],
        "startDate_": [{ type: core_1.Input, args: ['mnStartDate',] },],
        "endDate_": [{ type: core_1.Input, args: ['mnEndDate',] },],
        "_view": [{ type: core_1.Input, args: ['mnView',] },],
        "_multiple": [{ type: core_1.Input, args: ['mnMultiple',] },],
        "_disabled$": [{ type: core_1.Input, args: ['mnDisabled',] },],
        "_result": [{ type: core_1.Output, args: ['mnResult',] },],
        "_selected": [{ type: core_1.Output, args: ['mnSelected',] },],
    };
    return MnDateMultipleComponent;
}());
exports.MnDateMultipleComponent = MnDateMultipleComponent;
//# sourceMappingURL=mn-date-multiple.component.js.map