"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mn_date_class_1 = require("./mn-date.class");
var mu = require("mzmu");
/**
 * 构建日期视图
 */
var MnDatePickerComponent = (function () {
    function MnDatePickerComponent() {
        this._$selected = {};
        this._startPlaceHolder = 'Start Date';
        this._endPlaceHolder = 'End Date';
        this._formatter = 'yyyy-MM-dd';
        this._view = 'days';
        this._multiple = true;
        this._disabled = false;
        this._disabled$ = false;
        this._result = new core_1.EventEmitter();
        this._selected = new core_1.EventEmitter();
    }
    Object.defineProperty(MnDatePickerComponent.prototype, "maxDate_", {
        set: function (dt) {
            this._maxDate = new mn_date_class_1.MnDate(dt);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDatePickerComponent.prototype, "minDate_", {
        set: function (dt) {
            this._minDate = new mn_date_class_1.MnDate(dt);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDatePickerComponent.prototype, "startDate_", {
        set: function (dt) {
            this._startDate = new mn_date_class_1.MnDate(dt);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDatePickerComponent.prototype, "endDate_", {
        set: function (dt) {
            if (this._multiple) {
                this._endDate = new mn_date_class_1.MnDate(dt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnDatePickerComponent.prototype, "disabled_", {
        set: function (disabled) {
            this._disabled$ = disabled;
            this._disabled = disabled;
        },
        enumerable: true,
        configurable: true
    });
    MnDatePickerComponent.prototype.ngOnInit = function () {
    };
    MnDatePickerComponent.prototype.getResult = function (rst) {
        this._disabled = rst.disabled;
        this._setSelected(rst.startDate, rst.endDate);
        this._result.emit(rst);
    };
    MnDatePickerComponent.prototype.getSelected = function (rst) {
        this._setSelected(rst.startDate, rst.endDate);
        this._dropDownResult.hide();
    };
    MnDatePickerComponent.prototype._setSelected = function (start, end) {
        var _this = this;
        this._$selected = {};
        mu.run(start, function () {
            _this._$selected.start = mu.format(start._date, _this._formatter);
            _this._startDate = start;
        });
        mu.run(end, function () {
            _this._$selected.end = mu.format(end._date, _this._formatter);
            _this._endDate = end;
        });
        this._selected.emit({
            startDate: start,
            endDate: end
        });
    };
    MnDatePickerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'mn-datepicker',
                    encapsulation: core_1.ViewEncapsulation.None,
                    styles: ['mn-datesingle,mn-datecalendar,mn-datedraw,mn-datemultiple,mn-datepicker {  display: block;}mn-datepicker .mnc-picker {  padding-right: 8px;  height: 28px !important;  border: 1px solid #dedede;  border-radius: 3px;}mn-datepicker .mnc-picker mn-input {  height: 100%;  border: 1px solid transparent;  min-width: 105px;}mn-datepicker .mnc-picker mn-input .mn-input {  text-align: center;}mn-datemultiple.disabled {  position: relative;}mn-datemultiple.disabled:before {  position: absolute;  left: -8px;  top: -8px;  bottom: -8px;  right: -8px;  content: \' \';  background: rgba(0, 0, 0, 0.05);  cursor: not-allowed;}.mnc-weekdays > mn-col,mn-datesingle {  margin-bottom: 2px;  padding: 4px;  width: 28px;  height: 28px;  text-align: center;  border-radius: 2px;  transition: color .3s ease;}mn-datedraw mn-datesingle.start {  background: rgba(61, 168, 245, 0.3);}mn-datedraw mn-datesingle.end {  background: rgba(61, 168, 245, 0.5);}mn-datedraw .range {  background: #e2f2fe;}mn-datedraw .hover {  background: #e2f2fe;}mn-datedraw .re-hover {  background: #fef2e2;}mn-datedraw .disabled {  color: #aaa !important;  background: rgba(0, 0, 0, 0.05) !important;  cursor: not-allowed !important;}mn-datedraw .max {  color: #aaa;  text-decoration: line-through;}mn-datedraw .min {  color: #aaa;  text-decoration: line-through;}mn-datedraw .current {  cursor: pointer;}mn-datedraw .current:not(.max):not(.min):hover {  background: rgba(237, 107, 117, 0.5);}mn-datedraw .next,mn-datedraw .prev {  color: #999;}'],
                    template: "\n        <mn-dropdown (mnResult)=\"_dropDownResult = $event\">\n            <mn-fill class=\"mnc-picker\" [ngClass]=\"{disabled: _disabled$ || _disabled}\">\n                <mn-col [span]=\"1\">\n                    <mn-input [mnPlaceHolder]=\"_multiple ? _startPlaceHolder : 'Selected Date'\"\n                              [mnReadonly]=\"true\"\n                              [mnDisabled]=\"_disabled$ || _disabled\"\n                              [mnValue]=\"_$selected?.start\">\n                    </mn-input>\n                </mn-col>\n                <mn-col *ngIf=\"_multiple\">\n                    <span>~</span>\n                </mn-col>\n                <mn-col [span]=\"1\" *ngIf=\"_multiple\">\n                    <mn-input [mnPlaceHolder]=\"_endPlaceHolder\"\n                              [mnReadonly]=\"true\"\n                              [mnDisabled]=\"_disabled$ || _disabled\"\n                              [mnValue]=\"_$selected?.end\">\n                    </mn-input>\n                </mn-col>\n                <mn-col>\n                    <i class=\"fa fa-calendar mnc-next\"></i>\n                </mn-col>\n            </mn-fill>\n\n            <mn-dropdown-content class=\"p-8 mnc-block\">\n                <mn-datemultiple\n                        [ngClass]=\"{disabled: _disabled$ || _disabled}\"\n                        [mnMinDate]=\"_minDate\"\n                        [mnMaxDate]=\"_maxDate\"\n                        [mnStartDate]=\"_startDate\"\n                        [mnEndDate]=\"_endDate\"\n                        [mnView]=\"_view\"\n                        [mnDisabled]=\"_disabled$ || _disabled\"\n                        [mnMultiple]=\"_multiple\"\n                        (mnSelected)=\"getSelected($event)\"\n                        (mnResult)=\"getResult($event)\"></mn-datemultiple>\n            </mn-dropdown-content>\n        </mn-dropdown>\n\n    "
                },] },
    ];
    /** @nocollapse */
    MnDatePickerComponent.ctorParameters = function () { return []; };
    MnDatePickerComponent.propDecorators = {
        "_startPlaceHolder": [{ type: core_1.Input, args: ['mnStartPlaceHolder',] },],
        "_endPlaceHolder": [{ type: core_1.Input, args: ['mnEndPlaceHolder',] },],
        "_formatter": [{ type: core_1.Input, args: ['mnFormatter',] },],
        "_view": [{ type: core_1.Input, args: ['mnView',] },],
        "_multiple": [{ type: core_1.Input, args: ['mnMultiple',] },],
        "maxDate_": [{ type: core_1.Input, args: ['mnMaxDate',] },],
        "minDate_": [{ type: core_1.Input, args: ['mnMinDate',] },],
        "startDate_": [{ type: core_1.Input, args: ['mnStartDate',] },],
        "endDate_": [{ type: core_1.Input, args: ['mnEndDate',] },],
        "disabled_": [{ type: core_1.Input, args: ['mnDisabled',] },],
        "_result": [{ type: core_1.Output, args: ['mnResult',] },],
        "_selected": [{ type: core_1.Output, args: ['mnSelected',] },],
    };
    return MnDatePickerComponent;
}());
exports.MnDatePickerComponent = MnDatePickerComponent;
//# sourceMappingURL=mn-date-picker.component.js.map