"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mn_date_class_1 = require("./mn-date.class");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
var mu = require("mzmu");
var MnDatetimeServices = (function () {
    function MnDatetimeServices() {
        this.date$ = new BehaviorSubject_1.BehaviorSubject({});
    }
    MnDatetimeServices.prototype.setDate = function (value) {
        this.date$.next(value);
    };
    MnDatetimeServices.prototype.getRangeDate = function (rule) {
        var mndate = new mn_date_class_1.MnDate(new Date());
        var _range_map = {
            y: 'year_range',
            M: 'month_range',
            d: 'range',
            w: 'week_range',
            q: 'quarter_range'
        };
        var _rule = function (rule) {
            var regx = /(([-+]|)\d{1,})([:]|)([yMdhmsSqw])$/i;
            var rst = (rule || '').match(regx);
            return [rst[1], rst[4], rst[3]];
        };
        var _getRangeDate = function (diff, type, begin) {
            diff = parseInt((diff + ''), 10);
            var _map = {
                y: 'yoy',
                M: 'mom',
                d: 'dod',
                h: 'sos',
                m: 'sos',
                s: 'sos',
                S: 'sos',
                q: 'qoq',
                w: 'wow',
            };
            // todo mom -> mm
            return mndate[_map[type]](diff, begin);
        };
        // if (mu.isNotExist(rule)) {
        //     return;
        // }
        var _a = rule.split(','), _r1 = _a[0], _r2 = _a[1];
        var _start, _end;
        var _endType;
        mu.run(mu.trim(_r1 || ''), function (_r1) {
            var _rst = _rule(_r1) || [];
            var _diff = _rst[0], _type = _rst[1], _begin = _rst[2];
            _endType = !!_begin;
            _start = _getRangeDate(_diff, _type, _endType);
        });
        _end = mu.run(mu.trim(_r2 || ''), function (_r2) {
            var _rst = _rule(_r2) || [];
            var _diff = _rst[0], _type = _rst[1], _begin = _rst[2];
            _end = _getRangeDate(_diff, _type, _begin);
            if (_begin) {
                _end = _start[_range_map[_type]].end;
                // _start = _start[_range_map[_type]].start;
            }
        });
        if (!_end) {
            if (_endType) {
                // todo 计算获得结束时间
            }
            else {
                _end = mndate;
            }
        }
        var rst = [_start, _end].sort(function (a, b) {
            return a.days.start > b.days.start ? 1 : -1;
        });
        return {
            startDate: rst[0],
            endDate: rst[1],
        };
    };
    MnDatetimeServices.prototype.reStartDate = function (startDate, maxDate, minDate) {
        if (mu.isEmpty(startDate)) {
            return startDate;
        }
        if (maxDate || minDate) {
            if (minDate && (startDate.days.start < minDate.days.start)) {
                startDate = minDate;
            }
            if (maxDate && (startDate.days.start > maxDate.days.start)) {
                startDate = void 0;
            }
        }
        return startDate;
    };
    MnDatetimeServices.prototype.reEndDate = function (endDate, maxDate, minDate) {
        if (mu.isEmpty(endDate)) {
            return endDate;
        }
        if (maxDate || minDate) {
            if (maxDate && endDate.days.start > maxDate.days.start) {
                endDate = maxDate;
            }
            if (minDate && minDate.days.start > endDate.days.start) {
                endDate = void 0;
            }
        }
        return endDate;
    };
    /**
     * 获得当前时间的视图数据
     * @param _date
     * @param {string} view
     */
    /**
         * 获得当前时间的视图数据
         * @param _date
         * @param {string} view
         */
    MnDatetimeServices.prototype.getCalendar = /**
         * 获得当前时间的视图数据
         * @param _date
         * @param {string} view
         */
    function (_date, view) {
        var _views;
        switch (view) {
            case 'days':
                return this.getCalendarWithDays(_date);
            case 'weeks':
                return this.getCalendarWithWeeks(_date);
            case 'months':
                return this.getCalendarWithMonths(_date);
            case 'quarters':
                return this.getCalendarWithQuarters(_date);
            case 'years':
                return this.getCalendarWithYears(_date);
        }
    };
    MnDatetimeServices.prototype.getCalendarWithDays = function (_date) {
        _date = new mn_date_class_1.MnDate(_date);
        var _cds = mu.map(6, function (i) {
            return new Array(7);
        }, []);
    };
    MnDatetimeServices.prototype.getCalendarWithWeeks = function (_date) {
    };
    MnDatetimeServices.prototype.getCalendarWithMonths = function (_date) {
    };
    MnDatetimeServices.prototype.getCalendarWithQuarters = function (_date) {
    };
    MnDatetimeServices.prototype.getCalendarWithYears = function (_date) {
    };
    /**
     * v2
     */
    /**
     * 根据当前视图比较两个时间
     * @param view
     * @param src
     * @param target
     *
     * @return 1 大于; 0: 等于; -1: 小于; 2 范围内; -2 有交集
     */
    /**
         * v2
         */
    /**
         * 根据当前视图比较两个时间
         * @param view
         * @param src
         * @param target
         *
         * @return 1 大于; 0: 等于; -1: 小于; 2 范围内; -2 有交集
         */
    MnDatetimeServices.prototype.compared = /**
         * v2
         */
    /**
         * 根据当前视图比较两个时间
         * @param view
         * @param src
         * @param target
         *
         * @return 1 大于; 0: 等于; -1: 小于; 2 范围内; -2 有交集
         */
    function (view, src, target) {
        if (mu.isEmpty(src) || mu.isEmpty(target)) {
            return;
        }
        src = new mn_date_class_1.MnDate(src);
        target = new mn_date_class_1.MnDate(target);
        var _src = src[view];
        var _target = target[view];
        if (_src.start > _target.end) {
            return 1;
        }
        else if (_src.end < _target.start) {
            return -1;
        }
        else if (_src.start === _target.start && _src.end === _target.end) {
            return 0;
        }
        else if (_src.start < _target.start && _target.end < _src.end) {
            return 2;
        }
        else {
            return -2;
        }
    };
    /**
     * 判断当前时间是否在时间范围之内
     * @param view
     * @param src
     * @param min
     * @param max
     * @return {number} 2 范围内，0 小于最小值， 1 大于最大值
     */
    /**
         * 判断当前时间是否在时间范围之内
         * @param view
         * @param src
         * @param min
         * @param max
         * @return {number} 2 范围内，0 小于最小值， 1 大于最大值
         */
    MnDatetimeServices.prototype.range = /**
         * 判断当前时间是否在时间范围之内
         * @param view
         * @param src
         * @param min
         * @param max
         * @return {number} 2 范围内，0 小于最小值， 1 大于最大值
         */
    function (view, src, min, max) {
        if (mu.isEmpty(src)) {
            return;
        }
        if (mu.isEmpty(min)) {
            min = new mn_date_class_1.MnDate('1/1/1');
        }
        if (mu.isEmpty(max)) {
            min = new mn_date_class_1.MnDate('9999/1/1');
        }
        var _src = src[view];
        var _min = min[view];
        var _max = max[view];
        if (_min.start <= _src.start && _src.end <= _max.end) {
            return 2;
        }
        else if (_min.end > _src.star) {
            return 0;
        }
        else if (_src.end > _max.start) {
            return 1;
        }
    };
    MnDatetimeServices.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MnDatetimeServices.ctorParameters = function () { return []; };
    return MnDatetimeServices;
}());
exports.MnDatetimeServices = MnDatetimeServices;
//# sourceMappingURL=mn-datetime.services.js.map