"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mu = require("mzmu");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var platform_browser_1 = require("@angular/platform-browser");
var ExtraModules = (function () {
    function ExtraModules() {
    }
    return ExtraModules;
}());
exports.ExtraModules = ExtraModules;
function createComponentFactory(compiler, template, extraModules) {
    // const compMetadata = new Component({
    //     selector: 'dynamic-html',
    //     template: template
    // });
    // const cmpClass = class DynamicTemplateComponent {
    // };
    // const decoratedCmp = Component(compMetadata)(cmpClass);
    var _DecoratedCmp = (function () {
        function _DecoratedCmp() {
        }
        _DecoratedCmp.decorators = [
            { type: core_1.Component, args: [{
                        selector: 'decorated-cmp',
                        template: template
                    },] },
        ];
        return _DecoratedCmp;
    }());
    var DynamicHtmlModule = (function () {
        function DynamicHtmlModule() {
        }
        DynamicHtmlModule.decorators = [
            { type: core_1.NgModule, args: [{
                        imports: [
                            common_1.CommonModule,
                            platform_browser_1.BrowserModule,
                            router_1.RouterModule
                        ].concat(extraModules.items),
                        entryComponents: [
                            _DecoratedCmp
                        ],
                        exports: [
                            _DecoratedCmp
                        ],
                        declarations: [_DecoratedCmp]
                    },] },
        ];
        return DynamicHtmlModule;
    }());
    return compiler.compileModuleAndAllComponentsAsync(DynamicHtmlModule).then(function (moduleWithComponentFactory) {
        return moduleWithComponentFactory.componentFactories.find(function (x) { return x.componentType === _DecoratedCmp; });
    });
}
exports.createComponentFactory = createComponentFactory;
var MnDynamicTemplateDirective = (function () {
    function MnDynamicTemplateDirective(_vcRef, _compiler, _extraModules) {
        this._vcRef = _vcRef;
        this._compiler = _compiler;
        this._extraModules = _extraModules;
    }
    MnDynamicTemplateDirective.prototype.ngOnChanges = function (changes) {
        var _this = this;
        mu.exist(changes['template'], function () {
            var template = _this.template;
            if (!template)
                return;
            if (_this._cmpRef) {
                _this._cmpRef.destroy();
            }
            createComponentFactory(_this._compiler, template, _this._extraModules).then(function (factory) {
                var injector = core_1.ReflectiveInjector.fromResolvedProviders([], _this._vcRef.parentInjector);
                _this._cmpRef = _this._vcRef.createComponent(factory, 0, injector, []);
                _this.instance = _this._cmpRef.instance;
                mu.each(_this.context || [], function (v, k) {
                    _this.instance[k] = v;
                });
            });
        });
        mu.exist(changes['context'], function () {
            mu.run(_this.instance, function () {
                mu.each(_this.context, function (v, k) {
                    _this.instance[k] = v;
                });
            });
        });
    };
    MnDynamicTemplateDirective.prototype.ngOnDestroy = function () {
        if (this._cmpRef) {
            this._cmpRef.destroy();
        }
    };
    MnDynamicTemplateDirective.decorators = [
        { type: core_1.Directive, args: [{ selector: 'dynamic-template' },] },
    ];
    /** @nocollapse */
    MnDynamicTemplateDirective.ctorParameters = function () { return [
        { type: core_1.ViewContainerRef, },
        { type: core_1.Compiler, },
        { type: ExtraModules, },
    ]; };
    MnDynamicTemplateDirective.propDecorators = {
        "template": [{ type: core_1.Input },],
        "context": [{ type: core_1.Input },],
    };
    return MnDynamicTemplateDirective;
}());
exports.MnDynamicTemplateDirective = MnDynamicTemplateDirective;
//# sourceMappingURL=mn-dynamic-template.directive.js.map