"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mu = require("mzmu");
var MnLayerContainerService = (function () {
    function MnLayerContainerService() {
        this._nextUniqueId = 1;
    }
    MnLayerContainerService.prototype.ngOnDestroy = function () {
        var _this = this;
        mu.run(mu.prop(this, '_containerElement.parentNode'), function (_parent) { return _parent.removeChild(_this._containerElement); });
    };
    MnLayerContainerService.prototype.getContainer = function () {
        var _this = this;
        mu.empty(this._containerElement, function () { return _this._createContainer(); });
        return this._containerElement;
    };
    MnLayerContainerService.prototype._createContainer = function () {
        var container = document.createElement('div');
        container.classList.add('mnc-layer-container');
        document.body.appendChild(container);
        this._containerElement = container;
    };
    MnLayerContainerService.prototype.createLayerElement = function (moduleName, id) {
        if (id) {
            if (document.querySelector("#" + id)) {
                return document.querySelector("#" + id);
            }
            else {
                var ID = "mnc-layer-" + id;
                if (document.querySelector("#" + ID)) {
                    return document.querySelector("#" + ID);
                }
                else {
                    id = ID;
                }
            }
        }
        var _id = id || "mnc-layer-" + this._nextUniqueId++;
        var layer = document.createElement('div');
        layer.id = _id;
        layer.classList.add('mnc-layer');
        layer.classList.add(moduleName);
        this.getContainer().appendChild(layer);
        return layer;
    };
    MnLayerContainerService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MnLayerContainerService.ctorParameters = function () { return []; };
    return MnLayerContainerService;
}());
exports.MnLayerContainerService = MnLayerContainerService;
//# sourceMappingURL=mn-layer-container.service.js.map