"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var MnModalContext = (function () {
    function MnModalContext() {
        this.$implicit = null;
        this.mnLayer = null;
    }
    return MnModalContext;
}());
exports.MnModalContext = MnModalContext;
var MnModalComponent = (function () {
    function MnModalComponent(_render, _vcRef, _ref) {
        // this._render.setStyle(_ref.nativeElement, 'background', 'red');
        this._render = _render;
        this._vcRef = _vcRef;
        this._ref = _ref;
        this._mask = true;
        this._openChange = new core_1.EventEmitter();
        this._closed = new core_1.EventEmitter();
        this._opened = new core_1.EventEmitter();
        this._status = 'hide';
    }
    Object.defineProperty(MnModalComponent.prototype, "_open", {
        set: function (b) {
            if (b) {
                this._status = 'show';
                this._render.setStyle(document.body, 'overflow', 'hidden');
                this._opened.emit(true);
            }
            else {
                this._status = 'hide';
                this._render.removeStyle(document.body, 'overflow');
            }
        },
        enumerable: true,
        configurable: true
    });
    MnModalComponent.prototype.ngOnInit = function () {
    };
    MnModalComponent.prototype._result = function ($event) {
        this._modal = $event;
    };
    MnModalComponent.prototype.close = function () {
        this._modal.hide();
        this._open = false;
        this._openChange.emit(false);
        this._closed.emit(false);
    };
    MnModalComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'mn-modal',
                    template: "\n        <ng-template\n                [mnLayerId]=\"_layerId\"\n                [mnLayerModule]=\"'mnModal'\"\n                [mnLayerStatus]=\"_status\"\n                [mnLayerSourceRef]=\"_sourceRef\"\n                (mnResult)=\"_result($event)\"\n                mnLayer>\n            <section>\n                <div class=\"mnc-mask\" *ngIf=\"_mask\" (click)=\"close()\"></div>\n                <div class=\"mnc-modal\">\n                    <mn-panel [hph]=\"true\">\n                        <mn-panel-header>\n                            <mn-panel-title [innerHTML]=\"_title\">\n                            </mn-panel-title>\n                            <mn-panel-toolbar>\n                                <mn-col>\n                                    <i class=\"fa fa-close\" (click)=\"close()\"></i>\n                                </mn-col>\n                            </mn-panel-toolbar>\n                        </mn-panel-header>\n                        <mn-panel-body>\n\n                            <ng-container *ngIf=\"!_component\">\n                                <ng-content></ng-content>\n                            </ng-container>\n                            \n                            <ng-container *ngIf=\"_content\">\n                                <div [innerHTML]=\"_content\"></div>\n                            </ng-container>\n\n                            <ng-container *ngIf=\"_component\">\n                                <mn-dynamic-component [component]=\"_component\"></mn-dynamic-component>\n                            </ng-container>\n                        </mn-panel-body>\n                    </mn-panel>\n                </div>\n            </section>\n        </ng-template>\n    ",
                    styles: ['.mnc-layer-container {  position: fixed;  top: 0;  left: 0;  right: 0;  bottom: 0;  width: 100%;  z-index: 1000;  pointer-events: none;}.mnc-layer {  position: absolute;  z-index: 2;  border: 1px solid #eee;  background: #fff;  min-width: 10px;  box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.15);  pointer-events: auto;}.mnc-layer.mnc-hide {  visibility: hidden;  pointer-events: none;}.mnc-layer.mnc-show {  visibility: visible;  pointer-events: auto;}.mnc-mask {  position: fixed;  top: 0;  right: 0;  bottom: 0;  left: 0;  background: rgba(0, 0, 0, 0.3);}/** * modal * 弹出窗 */.mnc-layer.mnModal {  display: flex;  align-items: center;  width: 100%;  height: 100%;  background: transparent;}.mnc-layer.mnModal > section {  width: 100%;}.mnc-modal {  position: relative;  display: block;  margin: 0 auto;  width: 800px;  max-height: 96%;  overflow-y: auto;  background: #fff;}.mnc-layer.mn-modal {  text-align: center;}#mnc-layer-notify {  position: absolute;  right: 16px;  top: 8px;  width: 280px;}#mnc-layer-notify mn-alert {  margin-top: 8px;}/** * notify */.mnc-layer.mnNotify {  border: none;  box-shadow: none;  background: transparent;}.mnc-notify {  position: relative;}.mnc-notify .fa-close {  position: absolute;  top: -8px;  left: -8px;  z-index: 2;  width: 18px;  height: 18px;  line-height: 16px;  background: #fff;  border-radius: 50%;  border: 1px solid #0e77ca;  text-align: center;  color: #999;}.mnc-notify .fa-close.warning {  border: 1px solid rgba(222, 176, 52, 0.5);  color: rgba(222, 176, 52, 0.8);}.mnc-notify .fa-close.error {  border: 1px solid rgba(255, 0, 0, 0.5);  color: rgba(255, 0, 0, 0.8);}'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    MnModalComponent.ctorParameters = function () { return [
        { type: core_1.Renderer2, },
        { type: core_1.ViewContainerRef, },
        { type: core_1.ElementRef, },
    ]; };
    MnModalComponent.propDecorators = {
        "_title": [{ type: core_1.Input, args: ['mnTitle',] },],
        "_mask": [{ type: core_1.Input, args: ['mnMask',] },],
        "_source": [{ type: core_1.Input, args: ['mnSource',] },],
        "_component": [{ type: core_1.Input, args: ['mnComponent',] },],
        "_content": [{ type: core_1.Input, args: ['mnContent',] },],
        "_layerId": [{ type: core_1.Input, args: ['mnLayerId',] },],
        "_sourceRef": [{ type: core_1.Input, args: ['mnSourceRef',] },],
        "_open": [{ type: core_1.Input, args: ['mnOpen',] },],
        "_openChange": [{ type: core_1.Output, args: ['mnOpenChange',] },],
        "_closed": [{ type: core_1.Output, args: ['mnClosed',] },],
        "_opened": [{ type: core_1.Output, args: ['mnOpened',] },],
    };
    return MnModalComponent;
}());
exports.MnModalComponent = MnModalComponent;
//# sourceMappingURL=mn-modal.component.js.map