"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mn_modal_component_1 = require("./mn-modal.component");
var mn_layer_container_service_1 = require("./mn-layer-container.service");
var mn_notify_component_1 = require("./mn-notify.component");
var mu = require("mzmu");
var MnModalServices = (function () {
    function MnModalServices(_appRef, _cfr, _lcs) {
        this._appRef = _appRef;
        this._cfr = _cfr;
        this._lcs = _lcs;
    }
    MnModalServices.prototype.modal = function (config) {
        if (config === void 0) { config = {}; }
        if (config.id) {
            this._layer = this._lcs.createLayerElement('mnModal', config.id);
        }
        else if (!this._layer || (mu.prop(this._layer, 'className') || '').indexOf('mnModal') === -1) {
            this._layer = this._lcs.createLayerElement('mnModal');
        }
        this._layer.innerHTML = "<mn-modal></mn-modal>";
        this._mcf = this._cfr.resolveComponentFactory(mn_modal_component_1.MnModalComponent);
        var compRef = this._appRef.bootstrap(this._mcf, this._layer.firstElementChild);
        var instance = compRef.instance;
        instance['_title'] = config.title || '';
        instance['_mask'] = mu.ifnvl(config.mask, true);
        instance['_open'] = true;
        instance['_source'] = 'service';
        instance['_component'] = config.component;
        instance['_content'] = config.content;
        instance['_layerId'] = config.id || this._layer.id;
    };
    MnModalServices.prototype.notify = function (config) {
        if (config === void 0) { config = {}; }
        this._layer = this._lcs.createLayerElement('mnNotify', 'notify');
        var _section = document.createElement('mn-notify');
        // _section.innerHTML += `<mn-notify></mn-notify>`;
        this._mnf = this._cfr.resolveComponentFactory(mn_notify_component_1.MnNotifyComponent);
        // console.dir(this._layer);
        var compRef = this._appRef.bootstrap(this._mnf, _section);
        var instance = compRef.instance;
        instance['_open'] = true;
        instance['_type'] = config.type || 'error';
        instance['_source'] = 'service';
        instance['_content'] = config.content;
        instance['_layerId'] = config.id || this._layer.id;
        instance['_delay'] = mu.ifnvl(config.delay, 3000);
        instance['_closeBtn'] = mu.ifnvl(config.closeBtn, true);
        this._layer.appendChild(_section);
    };
    MnModalServices.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MnModalServices.ctorParameters = function () { return [
        { type: core_1.ApplicationRef, },
        { type: core_1.ComponentFactoryResolver, },
        { type: mn_layer_container_service_1.MnLayerContainerService, },
    ]; };
    return MnModalServices;
}());
exports.MnModalServices = MnModalServices;
//# sourceMappingURL=mn-modal.services.js.map