"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var MnNotifyComponent = (function () {
    function MnNotifyComponent(_render, _vcRef, _ref) {
        this._render = _render;
        this._vcRef = _vcRef;
        this._ref = _ref;
        // modal 来源 service 服务, page 页面
        this._source = 'service';
        this._closeBtn = false;
        this._openChange = new core_1.EventEmitter();
        this._closed = new core_1.EventEmitter();
        this._opened = new core_1.EventEmitter();
        this._status = 'hide';
    }
    Object.defineProperty(MnNotifyComponent.prototype, "_open", {
        set: function (b) {
            if (b) {
                this._status = 'show';
                this._opened.emit(true);
            }
            else {
                this._status = 'hide';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnNotifyComponent.prototype, "_delay", {
        set: function (value) {
            var _this = this;
            if (value) {
                this._delayId && clearTimeout(this._delayId);
                this._delayId = setTimeout(function () {
                    _this._close();
                }, value);
            }
        },
        enumerable: true,
        configurable: true
    });
    MnNotifyComponent.prototype.ngOnInit = function () {
    };
    MnNotifyComponent.prototype._result = function ($event) {
        this._layer = $event;
    };
    MnNotifyComponent.prototype._showResult = function ($event) {
        this._notify = $event.content;
    };
    MnNotifyComponent.prototype._close = function () {
        this._ref.nativeElement.remove();
        this._notify.remove();
        if (!this._layer.layer.childElementCount) {
            this._layer.hide();
        }
        this._openChange.emit(false);
        this._closed.emit(false);
        this._delayId && clearTimeout(this._delayId);
    };
    MnNotifyComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'mn-notify',
                    template: "\n        <ng-template\n                mnLayer\n                [mnLayerId]=\"'notify'\"\n                [mnLayerModule]=\"'mnNotify'\"\n                [mnLayerStatus]=\"_status\"\n                [mnLayerSourceRef]=\"_sourceRef\"\n                (mnShowResult)=\"_showResult($event)\"\n                (mnResult)=\"_result($event)\">\n\n            <section class=\"mnc-notify\">\n                <mn-alert\n                        [mnType]=\"_type\"\n                        [mnContent]=\"_content\">\n                </mn-alert>\n\n                <i class=\"fa fa-close {{_type}}\" (click)=\"_close()\" *ngIf=\"_closeBtn\"></i>\n            </section>\n\n        </ng-template>\n    ",
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    MnNotifyComponent.ctorParameters = function () { return [
        { type: core_1.Renderer2, },
        { type: core_1.ViewContainerRef, },
        { type: core_1.ElementRef, },
    ]; };
    MnNotifyComponent.propDecorators = {
        "_source": [{ type: core_1.Input, args: ['mnSource',] },],
        "_content": [{ type: core_1.Input, args: ['mnContent',] },],
        "_type": [{ type: core_1.Input, args: ['mnType',] },],
        "_closeBtn": [{ type: core_1.Input, args: ['mnCloseBtn',] },],
        "_open": [{ type: core_1.Input, args: ['mnOpen',] },],
        "_delay": [{ type: core_1.Input, args: ['mnDelay',] },],
        "_openChange": [{ type: core_1.Output, args: ['mnOpenChange',] },],
        "_closed": [{ type: core_1.Output, args: ['mnClosed',] },],
        "_opened": [{ type: core_1.Output, args: ['mnOpened',] },],
    };
    return MnNotifyComponent;
}());
exports.MnNotifyComponent = MnNotifyComponent;
//# sourceMappingURL=mn-notify.component.js.map