"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var mn_tab_component_1 = require("./mn-tab.component");
var mu = require("mzmu");
var MnTabsComponent = (function () {
    function MnTabsComponent() {
        this._options = {
            tabs: []
        };
        this._result = new core_1.EventEmitter();
        this._selected = new core_1.EventEmitter();
    }
    Object.defineProperty(MnTabsComponent.prototype, "options_", {
        set: 
        // opts = {
        //     tabs: [{
        //         name: '',
        //         template?: '',
        //         element?: '',
        //         component?: '',
        //         disabled: false,
        //     }],
        //
        //     active: 1,
        //     disabled: [2, 3]
        // }
        function (opts) {
            mu.run(mu.type(opts.template, 'object'), function () {
                opts._temp = opts.template;
                mu.remove(opts, 'template');
            });
            this._options = opts;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnTabsComponent.prototype, "active_", {
        set: function (val) {
            this._options.active = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MnTabsComponent.prototype, "tabs_", {
        set: function (tabs) {
            var _this = this;
            mu.run(tabs._results, function (rst) {
                _this._options.tabs = mu.map(rst, function (tab) {
                    return tab._options;
                });
            });
        },
        enumerable: true,
        configurable: true
    });
    MnTabsComponent.prototype.ngOnInit = function () {
    };
    MnTabsComponent.prototype._actived = function (key, inx, tab, tabs) {
        key = key || 0;
        if (key === tab.key || key === inx) {
            this._result.emit({
                tab: tab,
                index: inx,
                key: key
            });
            return true;
        }
        if (tabs.find(function (o, inx) { return o.key === key || inx === key; })) {
            return false;
        }
        var rst = inx === 0;
        if (rst) {
            this._result.emit({
                tab: tabs[0],
                index: inx,
                key: key
            });
        }
        return rst;
    };
    MnTabsComponent.prototype._clickTabTitle = function (tab, inx) {
        this._options.active = tab.key || inx;
        this._selected.emit({
            tab: tab,
            index: inx,
            key: tab.key
        });
    };
    MnTabsComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'mn-tabs',
                    template: "\n        <ng-content></ng-content>\n        <article>\n            <menu>\n                <ng-container *ngFor=\"let tab of _options?.tabs; let inx = index\">\n                    <nav [class.ms-tabActive]=\"_actived(_options.active, inx, tab, _options?.tabs)\">\n                        <a href=\"javascript:;\" [innerHTML]=\"tab?.title\"\n                           (click)=\"_clickTabTitle(tab, inx)\"></a>\n                    </nav>\n                </ng-container>\n            </menu>\n            <section>\n                <ng-container *ngFor=\"let tab of _options?.tabs; let inx = index\">\n                    <div *ngIf=\"_actived(_options.active, inx, tab, _options?.tabs)\">\n                        <div [innerHTML]=\"tab?.template\"></div>\n                        <ng-container *ngTemplateOutlet=\"tab._temp\"></ng-container>\n                    </div>\n                </ng-container>\n            </section>\n        </article>\n    ",
                    styles: ['mn-tabs {  display: block;}mn-tabs.card > article > menu > nav {  border: 1px solid #e7ecf1;  border-bottom-color: transparent;  border-radius: 4px;}mn-tabs.card > article > menu > nav.ms-tabActive {  border-bottom-color: #fff;}mn-tabs > article > menu {  padding: 0;  font-size: 0;  border-bottom: 1px solid #e7ecf1;}mn-tabs > article > menu > nav {  display: inline-block;  margin-bottom: -1px;  font-size: 14px;  border: 1px solid transparent;}mn-tabs > article > menu > nav.ms-tabActive {  color: #108ee9;  border-bottom-color: #108ee9;}mn-tabs > article > menu > nav.ms-tabActive > a {  color: #108ee9;}mn-tabs > article > menu > nav.ms-tabActive > a:hover {  color: #666;}mn-tabs > article > menu > nav > a {  display: block;  padding: 8px 16px;  width: 100%;  height: 100%;  text-decoration: none;  color: #666;}mn-tabs > article > menu > nav + nav {  margin-left: 2px;}mn-tabs > article > section {  padding: 16px;}'],
                    encapsulation: core_1.ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    MnTabsComponent.ctorParameters = function () { return []; };
    MnTabsComponent.propDecorators = {
        "options_": [{ type: core_1.Input, args: ['mnOptions',] },],
        "active_": [{ type: core_1.Input, args: ['mnActive',] },],
        "tabs_": [{ type: core_1.ContentChildren, args: [mn_tab_component_1.MnTabComponent,] },],
        "_result": [{ type: core_1.Output, args: ['mnResult',] },],
        "_selected": [{ type: core_1.Output, args: ['mnSelected',] },],
    };
    return MnTabsComponent;
}());
exports.MnTabsComponent = MnTabsComponent;
//# sourceMappingURL=mn-tabs.component.js.map